#include <TVout.h>
#include "Digits.h"
#include "ULetters.h"
#include "Special.h"

// #include <pollserial.h>
// #include <fontALL.h>

#define	Y_POS			10
#define	DIGIT_ZERO_X_POS	10
#define	DIGIT_ONE_XPOS		70


TVout	TV;


void	setup()
	{
	pinMode(2, INPUT); 
	pinMode(3, INPUT); 
	pinMode(4, INPUT); 
	pinMode(5, INPUT); 
	pinMode(6, INPUT); 
	pinMode(8, INPUT); 
	pinMode(10, INPUT); 

	pinMode(12, INPUT); 
	pinMode(13, INPUT); 
	pinMode(14, INPUT); 
	pinMode(15, INPUT); 
	pinMode(16, INPUT); 
	pinMode(17, INPUT); 
	pinMode(18, INPUT); 
	pinMode(19, INPUT); 
  
	TV.begin(_NTSC,128,90);
  //TV.select_font(font8x8);
  //TV.println("ABCDEFGHIJKLMNO");

	TV.bitmap(DIGIT_ZERO_X_POS, Y_POS, DIGITzero); 
	TV.bitmap(DIGIT_ONE_XPOS, Y_POS, DIGITzero);
	}


void	loop() 
	{
	byte  ch;
	static byte	ch_zero_last = -1, ch_one_last = -1;
 
  
	ch = getPortData(0);
 
	if(ch != ch_zero_last)
		{
		ch_zero_last = ch; 
		displayChar(0, ch);
		}


	ch = getPortData(1);
 
	if(ch != ch_one_last)
		{
		ch_one_last = ch; 
		displayChar(1, ch);
		}
	}


void	displayChar(char digit, byte ch)
	{
	int			x_pos;
	byte			asc;
	const unsigned 	char	*ptr;


	if(!digit)
		x_pos = DIGIT_ZERO_X_POS;
	else
		x_pos = DIGIT_ONE_XPOS;

	TV.draw_rect(x_pos,Y_POS,70,70,0,0);
    
	switch(ch)
		{
		case 0:
			ptr = DIGITzero;
			break;
		case 1:
			ptr = DIGITone;
			break;
		case 2:
			ptr = DIGITtwo;
			break;
		case 3:
			ptr = DIGITthree;
			break;
		case 4:
			ptr = DIGITfour;
			break;
		case 5:
			ptr = DIGITfive;
			break;
		case 6:
			ptr = DIGITsix;
			break;
		case 7:
			ptr = DIGITseven;
			break;
		case 8:
			ptr = DIGITeight;
			break;
		case 9:
			ptr = DIGITnine;
			break;
		case 10:
			ptr = LETTER_A;
			break;
		case 11:
			ptr = LETTER_B;
			break;
		case 12:
			ptr = LETTER_C;
			break;
		case 13:
			ptr = LETTER_D;
			break;
		case 14:
			ptr = LETTER_E;
			break;
		case 15:
			ptr = LETTER_F;
			break;

		case '0':
			ptr = DIGITzero;
			break;
		case '1':
			ptr = DIGITone;
			break;
		case '2':
			ptr = DIGITtwo;
			break;
		case '3':
			ptr = DIGITthree;
			break;
		case '4':
			ptr = DIGITfour;
			break;
		case '5':
			ptr = DIGITfive;
			break;
		case '6':
			ptr = DIGITsix;
			break;
		case '7':
			ptr = DIGITseven;
			break;
		case '8':
			ptr = DIGITeight;
			break;
		case '9':
			ptr = DIGITnine;
			break;

		case 'A':
			ptr = LETTER_A;
			break;
		case 'B':
			ptr = LETTER_B;
			break;
		case 'C':
			ptr = LETTER_C;
			break;
		case 'D':
			ptr = LETTER_D;
			break;
		case 'E':
			ptr = LETTER_E;
			break;
		case 'F':
			ptr = LETTER_F;
			break;
		case 'G':
			ptr = LETTER_G;
			break;
		case 'H':
			ptr = LETTER_H;
			break;
		case 'I':
			ptr = LETTER_I;
			break;
		case 'J':
			ptr = LETTER_J;
			break;
		case 'K':
			ptr = LETTER_K;
			break;
		case 'L':
			ptr = LETTER_L;
			break;
		case 'M':
			ptr = LETTER_M;
			break;
		case 'N':
			ptr = LETTER_N;
			break;
		case 'O':
			ptr = LETTER_O;
			break;
		case 'P':
			ptr = LETTER_P;
			break;
		case 'Q':
			ptr = LETTER_Q;
			break;
		case 'R':
			ptr = LETTER_R;
			break;
		case 'S':
			ptr = LETTER_S;
			break;
		case 'T':
			ptr = LETTER_T;
			break;
		case 'U':
			ptr = LETTER_U;
			break;
		case 'V':
			ptr = LETTER_V;
			break;
		case 'W':
			ptr = LETTER_W;
			break;
		case 'X':
			ptr = LETTER_X;
			break;
		case 'Y':
			ptr = LETTER_Y;
			break;
		case 'Z':
			ptr = LETTER_Z;
			break;
		default:
			return;  
		}

	TV.bitmap(x_pos,Y_POS,ptr);
	}


byte getPortData(char port)
	{
	byte	in = 0;


	if(!port)
		{
		in |= digitalRead(12) << 7;
		in |= digitalRead(13) << 6;
		in |= digitalRead(14) << 5;
		in |= digitalRead(15) << 4;
		in |= digitalRead(16) << 3;
		in |= digitalRead(17) << 2;
		in |= digitalRead(18) << 1;
		in |= digitalRead(19);
		}
	else
		{
		in |= digitalRead(10) << 6;
		in |= digitalRead(8) << 5;
		in |= digitalRead(6) << 4;
		in |= digitalRead(5) << 3;
		in |= digitalRead(4) << 2;
		in |= digitalRead(3) << 1;
		in |= digitalRead(2);
		}

	return(in);
	}
